
 /*     CHARTYPE.C      A Simple C Language program to show all
		     the character codes between 0 and 255 that
		     can be displayed by Character Typecasting!
                   [ Copyright(C)2001,2004 by Daniel B. Sedory. ]       */

 /*        Although BORLAND's old Turbo C++ (v 3.0) for DOS was used
      to compile this program, many other compilers should work just
      as well, since this source code is written in fairly simple C;
      if not the standard ANSI-C language itself.
           This code was recently compiled under Borland's C++ 5.5
      32-bit package for Windows, and runs under Win 2000/XP.           */

 /*     The "include" statements contain definitions from a library
     of fuctions that are part of most C/C++ compiler installations.
     Some "includes," like <stdio.h> are defined as part of the ANSI
     C Language, while others, such as <conio.h>, may be absent or
     vary in content from one compiler to the next.                     */

 #include <limits.h>
 #include <stdio.h>
 #include <conio.h>     /*  Contains the clrscr() function used below.  */

 void lastline(void);                /*  Prototypes of Functions which are */
 int dispchars(int start, int end);  /*  "defined" after main() below...   */

 main()                      /*   The MAIN FUNCTION of the whole program.  */

 {
    clrscr();                /*   Function Call to clear the screen.       */

    printf("\n\t   An Example  \"C Language\" Program  (C)2001 by The\
 Starman\n\n");

    printf("      This program shows all the *displayable* \"char\
 Typecast\" Characters.\n\n\n Each displayable character from Zero through\
 39 is surrounded by three dots:\n\n");

    printf("  From Zero through 12 (0Ch): ...");
    dispchars(0,12);

 printf("\n\t\tZero [and 32 (20h) shown below] display as a BLANK SPACE.\
 \n   7 produces a BEEP (but no character), 8 is a BACKSPACE, 9\
 is a TAB and\n  10 (a LINE FEED which also has a Carriage Return added to\
 it under C's\n  Character Typecasting) acts as a Newline function (as in\
 UNIX)!  13 (0Dh)\n  produces only a CARRIAGE RETURN (no Linefeed added);\
 it's not shown here.\n\n");

    printf("  From 14 through 25: ...");
    dispchars(14,25);

    printf("\n\n    Neither 26 (1Ah) CTRL-Z nor 27 (1Bh) the ESCAPE Key\
 produce displayable\n  characters using C's \"char Typecasting.\"\n\n");

    printf("  From 28 through 39: ...");
    dispchars(28,39);
    printf("\n\n");

    lastline();

    printf("\n From  40 (28h) through  47 (2Fh):      ");
    dispchars(40,47);
    printf("\n\n");

    printf(" From  48 (30h) through  57 (39h):      ");
    dispchars(48,57);
    printf("\n");

    printf(" From  58 (3Ah) through  64 (40h):      ");
    dispchars(58,64);
    printf("\n\n");

    printf(" From  65 (41h) through  90 (5Ah):      ");
    dispchars(65,74);
    printf("\n    ");
    dispchars(75,90);
    printf("\n\n\n");

    printf(" From  91 (5Bh) through  96 (60h):      ");
    dispchars(91,96);
    printf("\n\n");

    printf(" From  97 (61h) through 122 (7Ah):      ");
    dispchars(97,106);
    printf("\n    ");
    dispchars(107,122);
    printf("\n\n\n");

    printf(" From 123 (7Bh) through 127 (7Fh):      ");
    dispchars(123,127);
    printf("\n\n");

    lastline();

    printf("\n From 128 (80h) through 175 (AFh):      ");
    dispchars(128,137);
    printf("\n    ");
    dispchars(138,156);
    printf("\n    ");
    dispchars(157,175);
    printf("\n\n");

    printf(" From 176 (B0h) through 223 (DFh):      ");
    dispchars(176,185);
    printf("\n    ");
    dispchars(186,204);
    printf("\n    ");
    dispchars(205,223);
    printf("\n\n");

    printf(" From 224 (E0h) through 255 (FFh):      ");
    dispchars(224,233);
    printf("\n    ");
    dispchars(234,252);
    printf("\n    ");
    dispchars(253,255);
    printf("255 (FFh) displays as a BLANK SPACE.\n");

    printf("\n\n Press any key to EXIT the program ...");
    getch();
    clrscr();

      /*        TERMINATION of the main() program.		*/

    return 0;            /*    It's good practice to add this statement   */
 }			 /*    to the end of your main() function!        */

    /*    Zero is the normal return value for a program which has
	terminated correctly.                                             */


/* ====================================================================== */
/*		      FUNCTION  DEFINITIONS   begin  here :		  */

 void lastline(void)        /* A function which passes no data to main(). */
 {
    printf("\n  Press any key to continue ...");

/*   Note:  The following function is defined in the <conio.h> header.  */
    getch();      /* Using this function, the program 'appears to halt'
		      until the user presses a key. 			*/
    clrscr();     /* CLEAR SCREEN.  Also defined in the header above.	*/
    printf("\n");
 }


/* ----------------------------------------------------------------------*/
/*     The following function is defined as having integer ('int')
       parameters "passed" to it from the main() function above.         */

 int dispchars(int start, int end)
 {

   char CharVariable;          /*    Declarations of variables used    */
   int  x;		       /*    only within this function.        */

   for(x=start; x<=end; x++)
    {
      CharVariable = (char)x;  /*  This statement assigns the Character
				   "typecast" of the integer "x" to the
				   character variable, "CharVariable."   */
      if( x <= 39)
	 printf("%c...",CharVariable);
      else
	 printf("%c   ",CharVariable);
    }

   return 0;
 }

